--19 Dec 2010
--Search Track 02 (Hack)  i.e. As searchfield can not be focused on initialization vb.views
--is used to update the field via the key handler function.


local my_dialog = nil

-------------------------------------------------------------------------------------------
--Main
-------------------------------------------------------------------------------------------

function search_track ()

-------------------------------------------------------------------------------------------
--functions
-------------------------------------------------------------------------------------------

--generic handler which accepts an optional parameter

local function closer(d)

  if d then
    renoise.song().tracks_observable:remove_notifier(closer,my_dialog) --remove notifiers
    renoise.tool().app_release_document_observable:remove_notifier(closer, my_dialog)   
  end       
  
  if d and d.visible then             
      d:close()
  end
end


local function focus_pattern_ed()

renoise.app().window.lock_keyboard_focus = false
renoise.app().window.lock_keyboard_focus = true

end
-------------------------------------------------------------------------------------------

if (my_dialog and my_dialog.visible) then -- only allows one dialog instance
  my_dialog:show()
  return
end
  

local no_of_tracks = #renoise.song().tracks
local matching_string = nil
local current_track = renoise.song().selected_track_index 
local current_track_name =  renoise.song().tracks[current_track].name 
local vb = renoise.ViewBuilder()
local field_typing= false

local track_table = {}

for track = 1,no_of_tracks do
  track_table[track] = renoise.song().tracks[track].name
end

track_table[#track_table + 1] = "No Match"
-------------------------------------------------------------------------------------------
--GUI
-------------------------------------------------------------------------------------------
local dialog_content = vb:vertical_aligner {
                        margin = 8,
                        mode = "center",
                       
                        vb:textfield {
                        -- text = current_track_name,
                         id = "textfield",
                         width = 100,
                         
                         
                       --[[ notifier =
                        
function ()
 
  if not field_typing then

   for track = 1,no_of_tracks do
     local track_string = renoise.song().tracks[track].name
     local track_string_holder = track_string                   
     local found_match = string.find(track_string,vb.views["textfield"].value)--normal
     
      if found_match ~= nil then
        renoise.song().selected_track_index = track
        focus_pattern_ed()
        break

      else
        track_string = string.lower(track_string)
        found_match = string.find(track_string, vb.views["textfield"].value) --lower
        focus_pattern_ed()
      
        if found_match ~= nil then
          renoise.song().selected_track_index = track
          focus_pattern_ed()
          break
                                
        end
      end
    end
  end
 field_typing= false
end --]]
                        },
                        
                        vb:popup {
                           id = "popup",
                           width = 100,
                           value = current_track,
                           items = track_table,
                             notifier = function(number)
                         
                           -- renoise.song().selected_track_index = number
                            -- vb.views["textfield"].value = renoise.song().tracks[number].name
                         
                         end
                        },
                       }
----------------------------------------------------------------------------------------------------        
-- key handler
----------------------------------------------------------------------------------------------------
local string_holder = ""

local function my_keyhandler_func(dialog, key)
-- rprint(key)
-- print( key.character) 
  if (key.modifiers == "" and key.name == "esc") then
    closer(my_dialog)
  end
  

  
  if (key.modifiers == "control" and key.name == "back") then
    field_typing= true
    string_holder = ""
    vb.views["textfield"].value = string_holder
    vb.views["popup"].value = #track_table
      
    
        
  elseif key.name == "back" then 
    field_typing= true
    local string_minus_1
    string_minus_1 = string.sub(string_holder, 1, (string.len(string_holder)-1))--remove last character from string
    vb.views["textfield"].value = string_minus_1
    string_holder = string_minus_1
    
    if vb.views["textfield"].value == "" then --all deleted
      vb.views["popup"].value = #track_table
      return
    end
    
    --popup loop 1
    for track = 1,no_of_tracks do --search
      local track_string = renoise.song().tracks[track].name
      local track_string_holder = track_string                   
      local found_match = string.find(track_string,vb.views["textfield"].value)--normal
     
      if found_match ~= nil then --match found
        --renoise.song().selected_track_index = track
        vb.views["popup"].value = track
        break

      else  --no match
        track_string = string.lower(track_string)
        found_match = string.find(track_string, vb.views["textfield"].value) --lower
        vb.views["popup"].value = track
        if found_match ~= nil then
        break
     
      else
        vb.views["popup"].value = #track_table 
                                 
        end
      end
    end
    
    
  
       
  elseif key.name == "return" then
  
   if vb.views["textfield"].value == ("" or nil) then -- if blank field
     vb.views["popup"].value = #track_table 
     return
   end

    for track = 1,no_of_tracks do
      local track_string = renoise.song().tracks[track].name
      local track_string_holder = track_string                   
      local found_match = string.find(track_string,vb.views["textfield"].value)--normal
     
      if found_match ~= nil then
        renoise.song().selected_track_index = track
        focus_pattern_ed()
        closer(my_dialog)
        break

      else
        track_string = string.lower(track_string)
        found_match = string.find(track_string, vb.views["textfield"].value) --lower
     
        if found_match ~= nil then
          renoise.song().selected_track_index = track
          focus_pattern_ed()
          closer(my_dialog)
        break
        
        else
        vb.views["popup"].value = #track_table 
                      
        end
      end
    end
        
  elseif key.character ~= nil then --character input
    field_typing= true
    string_holder = string_holder..key.character 
    vb.views["textfield"].value = vb.views["textfield"].value..key.character 
    
    --popup loop
    for track = 1,no_of_tracks do --search
      local track_string = renoise.song().tracks[track].name
      local track_string_holder = track_string                   
      local found_match = string.find(track_string,vb.views["textfield"].value)--normal
     
      if found_match ~= nil then --match found
        --renoise.song().selected_track_index = track
        vb.views["popup"].value = track
        break

      else  --no match
        track_string = string.lower(track_string)
        found_match = string.find(track_string, vb.views["textfield"].value) --lower
        vb.views["popup"].value = track
        if found_match ~= nil then
        break
     
      else
        vb.views["popup"].value = #track_table 
                                 
        end
      end
    end
    
   
    
    
         
  end  
end                       
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
--Script dialog
my_dialog = renoise.app():show_custom_dialog(
    "Search For Track", dialog_content,my_keyhandler_func)


------------------------------------------------------------------------------------------
--notifiers
------------------------------------------------------------------------------------------
renoise.tool().app_release_document_observable:add_notifier(closer, my_dialog)
renoise.song().tracks_observable:add_notifier(closer,my_dialog)


    
    
end --end of main

renoise.tool():add_keybinding {
  name = "Global:Tools:Search Track 02",
  invoke = function()search_track()end
  
}



--[[local function check_closed() 
  
 if  not my_dialog.visible  then
   renoise.song().tracks_observable:remove_notifier(closer,my_dialog)
   renoise.song().tracks_observable:remove_notifier(closer,my_dialog)          
 end            
end--]]

